#include "iRRAM.h"

/* Compute iteration by J.M.Muller */

void jmm_double(int count){

  double a=11.0/2.0, b=61.00/11.0, c;

  for (long i=0;i<=count;i++ ) {
  
    rprintf("%13.10f",a); rprintf(" %d\n",i);

    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
}


void jmm_RATIONAL(int count){

  RATIONAL a=RATIONAL(11)/2, b=RATIONAL(61)/11, c;

  for (long i=0;i<=count;i++ ) {

    rwrite(REAL(a),18); rprintf(" %d\n",i);

    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
}

void jmm_REAL(int count){

  REAL a= REAL(11)/2, b=REAL(61)/11, c;

  for (long i=0;i<=count;i++ ) {

    rwrite(a,18); rprintf(" %d\n",i);

    c=111-(1130-3000/a)/b;
    a=b; b=c;   

  }
}


void compute(){
  int test,count;
  rprintf("\nJMM-example: c=111-(1130-3000/a)/b\n");
  rprintf("\nHow to compute (1=double, 2=RATIONAL, 3=REAL) : ");
  rscanf("%d",&test);
  rprintf("How many values: ");
  rscanf("%d",&count);
  rprintf("\n");
  switch (test) {
     case 3:;
       jmm_REAL(count);
     break;
     case 1:;
       jmm_double(count);
     break;
     case 2:;
       jmm_RATIONAL(count);
     break;
  }
  rprintf("\n");
};
